/*
 * NVRBM_kernel.cu
 *
 *  Created on: 4-Feb-2009
 *      Author: spoon
 */

#include "NVRBM_kernel.cuh"

/*
 * hidProbs in column-major order (numHid x numCases)!
 */
__global__ void kComputeSparseGrads(float* hidProbs, float* hidMeans, float sparseCost, float sparseTarget, float* sparseGrads,
                                    const unsigned int numCases, const unsigned int numHid) {
    const unsigned int idx = blockIdx.x * blockDim.x + threadIdx.x;

    for(unsigned int i = idx; i < numCases*numHid; i+= gridDim.x * blockDim.x) {
        sparseGrads[i] = sparseCost * (hidMeans[i / numCases] - sparseTarget) * hidProbs[i] * (1.0f - hidProbs[i]);
    }
}

//    for (int i = 0; i < myhid_probs->num_rows; i++) {
//        for (int j = 0; j < myhid_probs->num_cols; j++) {
//            *MAT_GET(mysparse_grads, i, j) = sparse_cost * ((*MAT_GET(myhid_means, 0, j) - sparse_target) * *MAT_GET(myhid_probs, i,j) * (1 - *MAT_GET(myhid_probs, i,j)));
//        }
//    }
